/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: flippara.h,v 1.4 1997/06/24 17:30:07 reichel Exp $ *
 ***********************************************************************/


//
// $Id: flippara.h,v 1.4 1997/06/24 17:30:07 reichel Exp $
// 
//
//     ---------------------
//	F L I P P A R A . H
//     ---------------------
//

#ifndef flippara
#define flippara

#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define tab '\t'
#define space ' '
#define sspace "  "

#define NAME_LENGTH 40
#define STRLENGTH 1000
typedef char name_string[NAME_LENGTH];
typedef name_string name;

enum colourtype {violet,blue,light_blue,turquoise,green,yellow,orange,
	red,pink,white,black,grey,light_grey,dark_grey,dark_blue,light_green,
	dark_green,light_red,dark_red,brown};

enum boolean {FALSE,TRUE};

//
//
//	* * * * * * * * * *   N a m e   * * *
//
//

class Name {
friend class NList;

public:

// * * constructors:
	Name(void) { strcpy(nam,"no_lingiustic_term"); next=NULL; };
	Name(name init_name)  { strcpy(nam,init_name); next=NULL; };

// * * complex methods:
	void show(void)              { cout << nam << space; };
	int  write(ofstream *output) { *output << nam << space; return 1; };
	int  read(ifstream *input)   { *input >> nam;           return 1; };

// * * simple methods to access data elements:
	void set_name(name new_n)    { strcpy(nam,new_n); next=NULL; };

	name *get_name(void)         { return &nam; };
	Name *get_next(void)         { return next; };

protected:
// * * data element:
	name nam;
	Name *next;
	};

//
//
//	* * * * * * * * * *  N L i s t  * * *
//
//
//	N a m e L i s t

class NList {

public:

// * * constructors:
	NList(void)       { first=NULL; last=NULL; number=0; };
	NList(int number);
	
	virtual ~NList(void);

// * * complex methods:
	void show(void);
	void show_NList(void)              { show(); };
	int  write(ofstream *output);
	int  write_NList(ofstream *output) { return write(output); };
	int  read(ifstream *input);
	int  read_NList(ifstream *input)   { return read(input); };
	void add(name new_name="no_linguistic_term");
	void add_NList(name new_n="no_linguistic_term") { add(new_n); };
	void copy(NList *n_list);
	void copy_NList(NList *n_list)     { copy(n_list); };
	Name *find(int index);
	Name *find_NList(int index)        { return find(index); };
	name *find_n(int index)            { return &(find(index)->nam); };
	name *operator [] (int index)      { return find_n(index); };
	void remove_all(void);

// * * simple methods to access data elements:
	void set_first(Name *nf)         { first=nf; };
	void set_first_NList(Name *nf)   { first=nf; };
	void set_last(Name *nl)          { last=nl; };
	void set_last_NList(Name *nl)    { last=nl; };
	void set_number(int nn)          { number=nn; };
	void set_number_NList(int nn)    { number=nn; };

	Name *get_first(void)       { return first; };
	Name *get_first_NList(void) { return first; };
	Name *get_last(void)        { return last; };
	Name *get_last_NList(void)  { return last; };
	int  get_number(void)       { return number; };
	int  get_number_NList(void) { return number; };

protected:
// * * data element:
	Name *first;
	Name *last;
	int number;
	};

//
//
//	* * * * * * * * * *   C o l o u r   * * *
//
//

class Colour {
friend class CList;

public:

// * * constructors:
	Colour(void)                   { colour=white;       next=NULL; };
	Colour(colourtype init_colour) { colour=init_colour; next=NULL; };

// * * complex methods:
	void show(void);
	int  write(ofstream *output);
	int  read(ifstream *input);

// * * simple methods to access data elements:
	void set_colour(colourtype new_c) { colour=new_c; };

	colourtype *get_colour(void) { return &colour; };
	Colour 	   *get_next(void)   { return next; };

protected:
// * * data elements:
	colourtype colour;
	Colour     *next;
	};

//
//
//	* * * * * * * * * *   C L i s t   * * *
//
//

class CList {

public:

// * * constructors:
	CList(void)  { first=NULL; last=NULL; number=0; };
	CList(int number);

	virtual ~CList(void);

// * * complex methods:
	void       show(void);
	void       show_CList(void) { show(); };
	void       rshow(Colour *c);
	int        write(ofstream *output);
	int        write_CList(ofstream *output) { return write(output); };
	int        read(ifstream *input);
	int        read_CList(ifstream *input) { return read(input); };
	void       add(colourtype new_colour = white);
	void       add_CList(colourtype new_c = white) { add(new_c); };
	void	   copy(CList *c_list);
	void	   copy_CList(CList *c_list) { copy(c_list); };
	Colour     *find(int index);
	Colour     *find_CList(int index) { return find(index); };
	colourtype *find_ct(int index)  { return &(find(index)->colour); };
	colourtype *operator [] (int index) { return find_ct(index); };
	void remove_all(void);

// * * simple methods to to access data elements:
	void set_first(Colour *nf)       { first=nf; };
	void set_first_CList(Colour *nf) { first=nf; };
	void set_last(Colour *nl)        { last=nl; };
	void set_last_CList(Colour *nl)  { last=nl; };
	void set_number(int nn)          { number=nn; };
	void set_number_CList(int nn)    { number=nn; };

	Colour *get_first(void)       { return first; };
	Colour *get_first_CList(void) { return first; };
	Colour *get_last(void)        { return last; };
	Colour *get_last_CList(void)  { return last; };
	int    get_number(void)       { return number; };
	int    get_number_CList(void) { return number; };

protected:
// * * data elements:
	Colour *first;
	Colour *last;
	int    number;
	};

//
//
//	* * * * * * * * * *   P a r a m e t e r S e t B a s e  * * *
//
//

class ParameterSetBase {

public:
// * * constructor:
	ParameterSetBase(void)
		{ range_lower_end=-100.0; range_upper_end=100.0;
		  median=0.0; distribution=0.95; dilatation=0,7;
		  importance=1; };

	ParameterSetBase(float new_range_lower_end,
		float new_range_upper_end, float new_median,
		float new_distribution,    float new_dilatation,
		float new_importance );

// * * complex methods:
	void         show(void);
	void         show_PSB(void)              { show(); };
	int          write(ofstream *output);
	int          write_PSB(ofstream *output) { return write(output); };
	int	     read(ifstream *input);
	int	     read_PSB(ifstream *input)   { return read(input); };
	void         copy(ParameterSetBase *psb);
	void         copy_PSB(ParameterSetBase *psb) { copy(psb); };

// * * simple methods to access data elements:
	void set_range_lower_end(float nrle) { range_lower_end=nrle; };
	void set_range_upper_end(float nrue) { range_upper_end=nrue; };
	void set_median(float nm)            { median=nm; };
	void set_distribution(float nd);
	void set_dilatation(float nd);
	void set_importance(float ni);

	float      get_range_lower_end(void) { return range_lower_end; }
	float      get_range_upper_end(void) { return range_upper_end; };
	float      get_median(void)          { return median; };
	float      get_distribution(void)    { return distribution; };
	float      get_dilatation(void)      { return dilatation; };
	float      get_importance(void)      { return importance; };

protected:
// * * data elements:
	float     range_lower_end;
	float     range_upper_end;
	float     median;
	float     distribution;
	float     dilatation;
	float     importance;
	};

//
//
//	* * * * * * * * * *   P a r a m e t e r S e t   * * *
//
//

class ParameterSet : public ParameterSetBase, public CList, public NList {
friend class PSList;

public:
// * * constructor:
	ParameterSet(void);
	ParameterSet(name new_ps_name, float new_range_lower_end,
		 float new_range_upper_end, float new_median,
		 float new_distribution, float new_dilatation,
		 float new_importance,
		 CList *new_c_list, NList *new_n_list );

// * * complex methods:
	void         show(void);
	int          write(ofstream *output);
	ParameterSet *read(ifstream *input);
	void         copy(ParameterSet *ps);

// simple methods to access data elements:
	void		 set_ps_name(name nn) { strcpy(ps_name,nn); };

	char             *get_ps_name(void)   { return ps_name; };
	ParameterSetBase *get_PSB(void);
	CList		 *get_CList(void);
	NList            *get_NList(void);
	ParameterSet     *get_next(void)      { return next; };

protected:
// * * data elements:
	name ps_name;
	ParameterSet *next;
	};

//
//
//	* * * * * * * * * *   P S L i s t  * * *
//
//

class PSList {

public:

// * * constructors:
	PSList(void) { first=NULL; last=NULL; number=0; };

// * * destructor:
	~PSList(void);

// * * complex methods:
	void show(void);
	int  write(ofstream *output);
	int  read(ifstream *input);
	void add(void);
	void add(ParameterSet *ps);
	void add(PSList *psl);
	ParameterSet *find(int index);
	void remove(int index);

// * * simple methods to access data elements:
	ParameterSet *get_first(void)       { return first; };
	ParameterSet *get_last(void)        { return last; };
	int   	     get_number(void)       { return number; };

// * * data elements:
	ParameterSet *first;
	ParameterSet *last;
	int number;
	};


#endif
