/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: fliptest.cpp,v 1.4 1997/06/24 17:30:10 reichel Exp $ *
 ***********************************************************************/


//
//     ------------------------------------
//	F L I P T E S T . C C  ( . C P P )
//     ------------------------------------
//

#include "flip.h"

main() {
cout.precision(3);
cout << endl << endl << endl;
cout << "                -----------------------------        "<< endl;
cout << "	       ---------------------------------      "<< endl;
cout << "	      |                                 |     "<< endl;
cout << "	    | |       F L I P  -  T E S T       | |   "<< endl;
cout << "	      |                                 |     "<< endl;
cout << "	       ---------------------------------      "<< endl;
cout << "	         -----------------------------        "<< endl;

// *** declare and allocate io-streams

ifstream *input = new ifstream;
ofstream *output = new ofstream;

// *** declare errorstring

char static error[100]=" ";

cout << endl << endl
     << tab << tab << "***********************************" << endl << endl
     << tab << tab << "P a r a m e t e r S e t  -  t e s t" << endl << endl
     << tab << tab << "***********************************" << endl;

cout << endl << "// * * create CList:" << endl;
	CList *cl1 = new CList(3);
	CList *cl2 = new CList(2);
	CList *cl3 = new CList(6);

cout << endl << "// * * show CList:" << endl;
	cl1->show();
	cl2->show();
	cl3->show();

cout << endl << "// * * create NList:" << endl;
// NList needet as paramter to create a ParameterSet
// !! the names are  n o t  allowed to include spaces !!
	NList *nl1 = new NList(3);
	NList *nl2 = new NList(2);
	NList *nl3 = new NList(4);

cout << endl << "// * * show NList:" << endl;
	nl1->show();
	nl2->show();
	nl3->show();

cout << endl << "// * * create ParameterSet:" << endl;
	ParameterSet *ps1,*ps2,*ps3;
	ps1 = new ParameterSet("ps1", -10, 10, 0, 0.9, 0.7, 1, cl1, nl1);
	ps2 = new ParameterSet("ps2", 0, 100, 50, 0.9, 0, 1, cl2, nl2);
	ps3 = new ParameterSet("ps3", -100, 100, 0, 0.7, 0.9, 1, cl3, nl3);

cout << endl << "// * * show ParameterSet:" << endl;
	ps1->show();
	ps2->show();
	ps3->show();

cout << endl << "// * * copy ParameterSet:" << endl;
	ParameterSet *psc = new ParameterSet;
	psc->copy(ps1);
	psc->show();

cout << endl << "// * * write ParameterSet:" << endl;
	output->open("flippara.dat");
	ps1->write(output);
	output->close();

cout << endl << "// * * show default ParameterSets for read:" << endl;
	ParameterSet *pse = new ParameterSet;
	pse->show();

cout << endl << "// * * read ParameterSets:" << endl;
	input->open("flippara.dat");
	pse->read(input);
	input->close();

cout << endl << "// * * show ParameterSets from file:" << endl;
	pse->show();

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

cout << endl << endl
     << tab << tab << "************************"
     << endl << endl
     << tab << tab << "P S L i s t   -  t e s t"
     << endl << endl
     << tab << tab << "************************"
     << endl;

cout << endl << "// * * create PSList:" << endl;
	PSList *ps_list = new PSList;

cout << endl << "// * *  test PSList add" << endl;
	ps_list->add(ps1);
	ps_list->add(ps2);
	ps_list->add(ps3);

cout << endl << "// * *  show PSList" << endl;
	ps_list->show();

cout << endl << "// * * write ps to file:" << endl;
	output->open("flippara.dat");
	ps_list->write(output);
	output->close();

cout << endl << "// * * clear and show PSList" << endl;
	ps_list->remove(2);
	ps_list->remove(1);
	ps_list->remove(0);
	ps_list->show();

cout << endl << "// * * read PSList from file:" << endl;
	input->open("flippara.dat");
	ps_list->read(input);
	input->close();

cout << endl << "// * * show PSList from file:" << endl;
	ps_list->show();

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

cout << endl << endl
     << tab << tab << "*******************************************"
     << endl << endl
     << tab << tab << "C o m b i n e d V a r i a b l e  -  t e s t"
     << endl << endl
     << tab << tab << "*******************************************"
     << endl;

cout << endl << "// * * construct CombinedVariable:" << endl;
	CombinedVariable *cv1 = new CombinedVariable(ps1,"cv1");
	CombinedVariable *cv2 = new CombinedVariable(ps2,"cv2");
	CombinedVariable *cv3 = new CombinedVariable(ps3,"cv3");

cout << endl << "// * *  test copy and show first empty cv and then copy"
     << endl;
	CombinedVariable *cvc = new CombinedVariable;
	cvc->show();
	cvc->copy(cv1);
	cvc->show();

cout << endl << "// * * test get_names_of_vars():" << endl;
	(cv1->get_names_of_vars())->show();

cout << endl << "// * * set_value" << endl;
	cv1->set_value(7);
	cv2->set_value(20);
	cv2->set_value(70);

cout << endl << "// * * show Variable:" << endl;
	cv1->show();
	cv2->show();
	cv3->show();

cout << endl << "// * * create File for CombinedVariables:" << endl;
	output->open("flipcvar.dat");

cout << endl << "// * * write cv to file:" << endl;
	cv1->write(output);
	output->close();

cout << endl << "// * * create and show default CombinedVariable"
	     <<	"for read:" << endl;
	CombinedVariable *cve = new CombinedVariable;
	cve->show();

cout << endl << "// * * read cv from file:" << endl;
	input->open("flipcvar.dat");
	cve->read(input);
	input->close();

cout << endl << "// * * show Variable from file:" << endl;
	cve->show();
	delete cve;

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

cout << endl << endl
     << tab  << tab << "************************"
     << endl << endl
     << tab  << tab << "C V L i s t   -  t e s t"
     << endl << endl
     << tab  << tab << "************************"
     << endl;

cout << endl << "// * * create CVList:" << endl;
	CVList *cv_list = new CVList;

cout << endl << "// * *  test CVList add" << endl;
	cv_list->add(cv1);
	cv_list->add(cv2);
	cv_list->add(cv3);

cout << endl << "// * *  show CVList" << endl;
	cv_list->show();

cout << endl << "// * * write cv to file:" << endl;
	output->open("flipcvar.dat");
	cv_list->write(output);
	output->close();

cout << endl << "// * * clear and show CVList" << endl;
	cv_list->remove_all();
	cv_list->show();

cout << endl << "// * * read CVList from file:" << endl;
	input->open("flipcvar.dat");
	cv_list->read(input);
	input->close();

cout << endl << "// * * show CVList from file:" << endl;
	cv_list->show();

cout << endl << "// * * clear and show CVList" << endl;
	cv_list->remove_all();
	cv_list->show();

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

cout << endl << endl
     << tab << tab << "*********************************" << endl << endl
     << tab << tab << "O p e r a t o r S e t  -  t e s t" << endl << endl
     << tab << tab << "*********************************" << endl;

cout << endl << "// * * create OperatorSet:" << endl;
	OperatorSet *operator_set = new OperatorSet;

cout << endl << "// * * show OperatorSet:" << endl;
	operator_set->show();

cout << endl << "// * * test set:" << endl;
	operator_set->set_accuracy(8);

cout << endl << "// * * write OperatorSet:" << endl;
	output->open("fliprule.dat");
	operator_set->write(output);
	output->close();

cout << endl << "// * * make default OperatorSets for read:" << endl;
	OperatorSet *ose = new OperatorSet;

cout << endl << "// * * read OperatorSet:" << endl;
	input->open("fliprule.dat");
	ose->read(input);
	input->close();

cout << endl << "// * * show OperatorSet from file:" << endl;
	ose->show();

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

cout << endl << endl
     << tab << tab << "*************************" << endl << endl
     << tab << tab << "R u l e S e t  -  t e s t" << endl << endl
     << tab << tab << "*************************" << endl;

cout << endl << "// * * create RuleSet:" << endl;
	RuleSet *rule_set = new RuleSet();

cout << endl << "// * * test OperatorSet - set:" << endl;
	rule_set->get_operator_set()->set_accuracy(12);
	rule_set->get_operator_set()->set_and_operator(ass_comp_and);
	rule_set->get_operator_set()->set_or_operator(ass_comp_or);
	rule_set->get_operator_set()->set_gamma(0.7);
	rule_set->get_operator_set()->set_certainty_operator(fuzzy_and);
	rule_set->get_operator_set()->set_inference_operator(fuzzy_and);

cout << endl << "// * * create ParameterSets:" << endl;
	ParameterSet *rps1,*rps2,*rps3;
	rps1 = new ParameterSet("ps1", -10, 10, 0, 0.9, 0.7, 1, cl1, nl1);
	rps2 = new ParameterSet("ps2", 0, 100, 50, 0.9, 0, 1, cl2, nl2);
	rps3 = new ParameterSet("ps3", -100, 100, 0, 0.7, 0.9, 1, cl3, nl3);

cout << endl << "// * *  test PSList add" << endl;
	rule_set->get_ps_list()->add(rps1);
	rule_set->get_ps_list()->add(rps2);
	rule_set->get_ps_list()->add(rps3);

cout << endl << "// * *  test RuleSet add" << endl;
	rule_set->add_BasicRule(cv1, "bad",
				cv2, "not_satisfied", 1);
	rule_set->add_BasicRule(cv1, "neutral",
				cv2, "satisfied", 1);
	rule_set->add_BasicRule(cv1, "good",
				cv2, "satisfied", 1);

	rule_set->add_ComplexRule(cv1, "bad",  cv2, "not_satisfied",
				cv3, "negative_big", AND, 1);
	rule_set->add_ComplexRule(cv1, "neutral",  cv2, "not_satisfied",
				cv3, "negative", AND, 1);
	rule_set->add_ComplexRule(cv1, "neutral",  cv2, "satisfied",
				cv3, "positive", AND, 1);
	rule_set->add_ComplexRule(cv1, "good",  cv2, "satisfied",
				cv3, "positive_big", AND, 1);

cout << endl << "// * * show RuleSet:" << endl;
	rule_set->show();

cout << endl << "// * *  show CVList" << endl;
	rule_set->get_cv_list()->show();

cout << endl << "// * *  test get_cv" << endl;
	rule_set->get_cv("cv1")->show();

cout << endl << "// * *  test get_cv from not existing cv" << endl;
	CombinedVariable *cvp;
	cvp=rule_set->get_cv("cv7");
	if (cvp!=NULL) cvp->show();

cout << endl << "// * * write RuleSet:" << endl;
	output->open("fliprule.dat");
	rule_set->write(output);
	output->close();

cout << endl << "// * * create 2nd RuleSet:" << endl;
	RuleSet *rule_set2 = new RuleSet();

cout << endl << "// * * read RuleSet:" << endl;
	input->open("fliprule.dat");
	rule_set2->read(input);
	input->close();

cout << endl << "// * * show RuleSet from file:" << endl;
	rule_set2->show();

cout << endl << "// * * show OperatorSet from file:" << endl;
	rule_set2->get_operator_set()->show();

cout << endl << "// * *  show CVList from file:" << endl;
	rule_set2->get_cv_list()->show();

cout << endl << "// * * show PSList from file:" << endl;
	rule_set2->get_ps_list()->show();

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

cout << endl << endl
     << tab << tab << "***************************" << endl << endl
     << tab << tab << "e v a l u a t e  -  t e s t" << endl << endl
     << tab << tab << "***************************" << endl;

cout << endl << "// * * evaluate cv3:" << endl;
	cv3->show();
	rule_set->evaluate(cv3);
	cv1->show();
	cv2->show();
	cv3->show();

if (strcmp(error," ")!=0) cout << endl << " ### error: " << error << endl;

	}; //   end of fliptest.cpp
